
$lib_info {"imaputf"} = "IMAP-UTF7R[hϊCu";
$lib_com  {"imaputf"} = "IMAP-UTF7R[hEUC/SJISɕϊ܂";
$lib_ver  {"imaputf"} = "1.0";
$lib_maker{"imaputf"} = "LunarNight";

#-------------------------------------------------------------------------------
#                           IMAP-UTF7R[hϊCu
#                           Ver1.0
# 
# ϊe[u(uni2sjis.datAuni2euc.dat)Kvł
#
#-------------------------------------------------------------------------------

package imap_utf_dec;

$uni2sjis_dat  = './lib/dat/uni2sjis.dat' ;
$uni2sjis1_dat = './lib/dat/uni2sjis1.dat';
$uni2euc_dat   = './lib/dat/uni2euc.dat'  ;

%uni2sjis_hash = ();
%uni2euc_hash  = ();
$uni2sjis_flag = 0;
$uni2euc_flag  = 0;

%b64_code = (
'A', '000000',  'B', '000001',  'C', '000010',  'D', '000011',
'E', '000100',  'F', '000101',  'G', '000110',  'H', '000111',
'I', '001000',  'J', '001001',  'K', '001010',  'L', '001011',
'M', '001100',  'N', '001101',  'O', '001110',  'P', '001111',
'Q', '010000',  'R', '010001',  'S', '010010',  'T', '010011',
'U', '010100',  'V', '010101',  'W', '010110',  'X', '010111',
'Y', '011000',  'Z', '011001',  'a', '011010',  'b', '011011',
'c', '011100',  'd', '011101',  'e', '011110',  'f', '011111',
'g', '100000',  'h', '100001',  'i', '100010',  'j', '100011',
'k', '100100',  'l', '100101',  'm', '100110',  'n', '100111',
'o', '101000',  'p', '101001',  'q', '101010',  'r', '101011',
's', '101100',  't', '101101',  'u', '101110',  'v', '101111',
'w', '110000',  'x', '110001',  'y', '110010',  'z', '110011',
'0', '110100',  '1', '110101',  '2', '110110',  '3', '110111',
'4', '111000',  '5', '111001',  '6', '111010',  '7', '111011',
'8', '111100',  '9', '111101',  '+', '111110',  ',', '111111',
);                                            #-~~~-- {'/' IMAP-UTF7ł","

return 1;

sub main::imap_utf_d{
	
	(*str,$mode) = @_;
	
	if ($mode eq "sjis"){
		$str =~ s/\&([A-Za-z0-9\+,]+)-/&uni2sjis($1)/ge;
	}else{
		$str =~ s/\&([A-Za-z0-9\+,]+)-/&uni2euc($1)/ge;
	}
	
}

sub uni2sjis{
	
	($str2) = @_;
	
	if ($uni2sjis_flag == 0){
		open(IN,$uni2sjis_dat);
		$uni2sjis_size = -s $uni2sjis_dat;
		binmode IN;
		$size = 0;
		while($size <= $uni2sjis_size){
			read(IN,$uni ,2);
			read(IN,$sjis,2);
			$size += 4;
			$uni2sjis_hash{$uni} = $sjis;
		}
		close(IN);
		open(IN,$uni2sjis1_dat);
		$uni2sjis1_size = -s $uni2sjis1_dat;
		binmode IN;
		$size = 0;
		while($size <= $uni2sjis1_size){
			read(IN,$uni ,2);
			read(IN,$sjis,1);
			$size += 3;
			$uni2sjis_hash{$uni} = $sjis;
		}
		close(IN);
		$uni2sjis_flag = 1;
	}
	
	
	$str2 =~ s/(.)/$b64_code{$1}/g;
	$str2 = pack('B*',$str2);
	
	$max = length($str2);
	$cnt = $max/2;
	$out = "";
	foreach $a (0.. $cnt){
		$out .= $uni2sjis_hash{substr($str2,$a*2,2)};
	}
	
	return($out);
}

sub uni2euc{
	
	($str2) = @_;
	
	if ($uni2euc_flag == 0){
		$uni2euc_size = -s $uni2euc_dat;
		open(IN,$uni2euc_dat);
		binmode IN;
		$size = 0;
		while($size <= $uni2euc_size){
			read(IN,$uni ,2);
			read(IN,$sjis,2);
			$size += 4;
			$uni2euc_hash{$uni} = $sjis;
		}
		close(IN);
		$uni2euc_flag = 1;
	}
	
	
	$str2 =~ s/(.)/$b64_code{$1}/g;
	$str2 = pack('B*',$str2);
	
	$max = length($str2);
	$cnt = $max/2;
	$out = "";
	foreach $a (0.. $cnt){
		$out .= $uni2euc_hash{substr($str2,$a*2,2)};
	}
	
	return($out);
}



