
#-------------------------------------------------------------------------------------------------------
#                          mailcontrol.plW[  - HTTPf[^擾W[
#
# Programmed by LunarNight
#-------------------------------------------------------------------------------------------------------

$def_port = "80";
$def_path = "/";
$str_buf  = "";
$def_size = "1024";

%def_header = ("accept" => '*/*',
               "accept-language" => "ja",
               "user-agent"      => "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)",
               "connection"      => "close");

return 1;

sub gethttp{
	
	($target,*post_data,*cookie_data,$refer) = @_;
	
	$port = $def_port;
	$path = $def_path;
	%add_head = ('referer' => $refer);
	
	
	#---URL
	$target =~ m!(\w+:)?(//)?([^:/]*)?(:([0-9]+)?)?(/.*)?!;
	if ($1 ne "http:" && $1 ne "https:"){ return('gethttp','analyzeurl',$target);}
	if ($1 eq "https:"){$port = "443";}
	if ($3) {$host = $3;}
	if ($5) {$port = $5;}
	if ($6) {$path = $6;}
	$prot = $1;
	
	if (index($host,"?") != -1){
		($host,$path) = split(/\?/,$host);
		$path = "/?".$path;
	}
	$addr = $path;
	
	#---ڑJn
	if ($port ne "443"){ ($rc,$type,$msg) = &open_tcp_connection($host,$port,"HTTP"); $http_ssl_flag = 0;}
	else               { ($rc,$type,$msg) = &open_ssl_connection($host,$port,"HTTP"); $http_ssl_flag = 1;}
	if ($rc ne "1"){ return('gethttp->'.$rc,$type,$msg);}
	

	#---NGXg쐬
	$post_str = &make_string(*post_data);
	
	if   (lc($add_head  {"connection"}) eq "keep-alive"   ){ $http_ver = "1.1";                 }
	elsif(lc($def_header{"connection"}) eq "keep-alive" &&
	      $data_jump eq ""                                ){ $http_ver = "1.1";                 }
	else                                                   { $add_head{"connection"} = "close";
	                                                         $http_ver = "1.0";                 }
	
	$add_head{"host"} = $host;
	if   ($post_str eq "" && $send_jump eq ""){ $head_str = "GET $addr HTTP/$http_ver\r\n";                       }
	elsif($send_jump ne ""                   ){ $head_str = "POST $addr HTTP/$http_ver\r\n";                      }
	else                                      { $add_head{"content-length"} = length($post_str);
	                                            $add_head{"content-type"  } = "application/x-www-form-urlencoded";
	                                            $head_str = "POST $addr HTTP/$http_ver\r\n";                      }
	
	#---Cookie
	while(($key,$val) = each %cookie_data){
		if ($flag == 0){ $add_head{"cookie"} = "";}
		$add_head{"cookie"} .= $key."=".$val."; ";
	}
	
	#---wb_[M
	%already_hash = ();
	while(($key,$val) = each %add_head){
		if ($key !~ /[\w-]/){ next;}
		$already_hash{$key} = 1;
		
		$key =~ s/(-[a-z])/uc($1)/oe;
		$key =~ s/^([a-z])/uc($1)/oe;
		
		$head_str .= $key.": ".$val."\r\n";
		
	}
	while(($key,$val) = each %def_header){
		if ($already_hash{$key} == 1){ next;}
		
		$key =~ s/(-[a-z])/uc($1)/oe;
		$key =~ s/^([a-z])/uc($1)/oe;
		
		$head_str .= $key.": ".$val."\r\n";
	}
	&http_tr($head_str."\r\n");
	
	if($post_str ne ""){ &http_tr("$post_str\r\n");}
	
	#---f[^M
	%http_outhead = ();
	$http_outdata = "";
	$http_res     = 1 ;
	$flag         = 0;
	
	$http_msg  = &http_rc();
	$http_msg  =~ tr/\r\n//d;
	$http_type = lc(substr($http_msg,0,8));
	
	#---wb_[ǂݍ
	while(1){
		
		$buf = &http_rc();
		
		#---؂ւ
		if ($buf eq "\r\n" || $buf eq "\n"){ last;}
		$buf =~ tr/\r\n//d;
		
		$data = index($buf,":");
		
		$key = substr($buf,0,$data);
		$val = substr($buf,$data+2);
		
		$http_outhead{lc($key)} .= $val;
		$http_outhead{lc($key)} .=";" if lc($key) eq "set-cookie";
	}
		
	#---KeepAlivemF
	$content_size = 0;
	if   ($http_type eq "http/1.1" && $http_outhead{"content-length"} eq ""){ $flag = 1;}
	elsif($http_type eq "http/1.1" && $http_outhead{"content-length"} ne ""){ $flag = 2;}
	else                                                                    { $flag = 3;}
		
	#---Keep-Alive^CvP
	$bad_data = "";
	if ($flag == 1){
		$content_size = &http_rc();
		
		$tmp = $content_size;
		$tmp =~ tr/\r\n\d//d;
		
		if ($tmp =~ /[^0-9a-fA-F]/ ||
		    $tmp eq ""            ){ $flag = 3;
			                           $bad_data = $content_size;                  }
		else                       { $http_outhead{"content-length"} = hex($tmp);}
	}
	
	#---Keep-Alive^CvQ
	if ($flag == 2 || $flag == 1){
		$content_size = $http_outhead{"content-length"};
		$buf_size     = 10240;
	}
	
	#---f[^擾^CvP
	if ($flag == 1 || $flag == 2){
		
		$last_f = 0;
		
		while($content_size > 0){
			
			if ($content_size <= $buf_size){ $read_size = $content_size;
			                                 $last_f = 1 if $flag == 1;
			                                 $content_size = 0;          }
			else                           { $read_size = $buf_size;
			                                 $content_size -= $buf_size; }
			
			$buf = &http_rc($read_size);
			$content_size += $read_size - length($buf);
			$http_outdata .= $buf;
			

			if ($last_f == 1){ $tmp = &http_rc();$tmp .= &http_rc();
			                   ($tmp) =~ /([a-fA-F0-9]+)/;
			                   $content_size = hex($tmp);
			                   
			                   if ($content_size != 0){ $last_f = 0;}
			                   else                   { last;       }
			                                                          }
		}
	}
	
	#---f[^擾^CvQ
	if ($flag == 3){
		if ($bad_data ne ""){ $buf = $bad_data;}
		
		while(1){
			$buf = &http_rc();
			$http_outdata .= $buf;
			if (index($buf,"\n") < 0){ last;}
		}
	}
	
	#---ڑؒf
	&close_connection("HTTP");
	
	return(1,$http_msg,$http_outdata,*http_outhead);
	
}

#---------------------------------------------------------------------------------------------------------------------
# QUERY_STRING쐬
#---------------------------------------------------------------------------------------------------------------------
sub make_string{
	
	$hennsuu = $_[0];
	
	$output2 = "";
	foreach $aa (keys(%$hennsuu)){
		if ($aa eq ""           ){ next;}
		if ($$hennsuu{$aa} eq ""){ next;}
		$value = $$hennsuu{$aa};
		$value =~ s/(\W)/'%' . unpack('H2', $1)/eg;
		$output2 .= $aa."=".$value."&";
	}
	
	$output2 = substr($output2,0,length($output2)-1);
	
	return ($output2);
	
}