
#-------------------------------------------------------------------------------------------------------
# Ytt@C擾
# &imap4getfile(<Pointer>,<ConfigPointer>);
# 
# Input: <Pointer>HashPointer                      <ConfigPointer>HashPointer
#         => mailno   -- <TargetMailNo>            => imap_server   --- IMAP Server
#            pnt_no   -- <PartPoint>                  imap_port     --- IMAP Port
#            mailbox  -- <TargetMainBox>              imap_account  --- IMAP Account
#            script_h   -- <wb_o̓[eB>     imap_password --- IMAP Password
#            script_b   -- <{fBo̓[eB>     imap_ssl      --- IMAP over SSL (ssl|"")
#
#            auto_enc   -- <[1|0]ftHg[eBI[gGR[h>
#            mojicode   -- wb_[o͕R[h
#
# DefaultOutput: <OutputPointer>
#         => <OutputPointer>
#             
#             content_type -- Content-Type
#             content_id   -- Content-ID
#             content_name -- Name
#             content_enc  -- Content-Transfer-Encoding
#             
#             content_body -- MainBody (NotEncoded)
#
# return(<DefaultOutputPointer>);  <== script_bw莞͖
# 
# ScriptSubRoutin
# 
# F&<`o̓[eB>(<ScalarPointer>,[not use header routin]<HashPointer>);
#    <ScalarPointer> -- BodyStream
#    <HashPointer>   -- wb_[o̓[eBpȂ̂݁A
#                       =>content_type -- Content-Type
#                         content_id   -- Content-ID
#                         content_name -- Name
#                         content_enc  -- Content-Transfer-Encoding
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4getfile{

	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	#---eϐ^ݒ擾
	$mailno   = $lib_pointer{"mailno"  };
	$mailbox  = $lib_pointer{"mailbox" };
	$pnt_no   = $lib_pointer{"pnt_no"  };
	$script_h = $lib_pointer{"script_h"};
	$script_b = $lib_pointer{"script_b"};
	$auto_enc = $lib_pointer{"auto_enc"};
	$mojicode = $lib_pointer{"mojicode"};
	
	if ($mojicode eq ""){ $mojicode = "EUC";        }
	else                { $mojicode = uc($mojicode);}
	
	#---ڑmF
	if($login_ctl{"imap"} != 1 ){ return('imap4getfile','notlogin','IMAP4'); }
	
	#---[{bNXI
	($rc,$rec,$max_cnt) = &execute('imap4select',$mailbox);
	if ($rc ne "1"){ return('imap4getfile','select',$rec."\n".$max_cnt);}

	#---[MJn
	&imap4_tr("0000 FETCH $mailno RFC822\r\n");
	$msg = &imap4_rc();
	if (substr($msg,0,4) eq "0000"){ return('imap4getfile','fetch',$rc."\n".$com);}
	($total_size) = $msg =~ /\{(\d+)\}/;
	
	
	#---ϐ
	%output_filedata = ();
	%output_optdata  = ();
	
	#---etO
	$part_flag    = "header";
	$header_flag  = "";
	$body_head[0] = "header";
	$body_cnt[0]  = 0;
	$now_bcnt     = 0;
	@now_boundary = "";
	$now_pnt      = "000";
	$d_flag       = "";
	$nowsize      = 0;
	
	#---alarm~߂
	if ($timeout_time ne ""){ alarm(0);}
	
	while(1){
		
		if ($nowsize >= $total_size){ last;}
		$buf = $msg = &imap4_rc();
		
		$nowsize += length($msg);
		$msg =~ s/\r//;
		
		#---p[gtOF
		if ($msg eq "\n"){ $part_flag = "body";}

		#---wb_[
		if ($part_flag eq "header"){
			
			if ($now_pnt eq $pnt_no){
				
				if ($script_h ne ""){
					
					&$script_h(*msg);
				
				}else{
					
					chomp $msg;
					
					#---wb_[ MIME Decode R[hEUC
					$msg = &main::mimedecode($msg, $mojicode);
					
					#---wb_[F^ϐ
					if    ($msg =~ /^content-type/oi             ){ $output_optdata{"content_type"} = substr($msg,14);}
					elsif ($msg =~ /^content-transfer-encoding/oi){ $output_optdata{"content_enc" } = substr($msg,27);}
					
					$next_flag = "1";
					
				}
				
			}else{
				
				chomp $msg;
				
				#---MultiPartBoundaryo
				if    ($msg =~ /boundary=/oi   ){ ($boundary) = $msg =~ /boundary\s*=\s*"([^"]+)"/io;
				                                  ($boundary) = $msg =~ /boundary\s*=\s*([$ascii]+)/io unless $boundary;
				                                  $now_boundary[$now_bcnt] = $boundary;
				                                                                                                           }
				
			}
		}
		
		#---{fB[
		if ($part_flag eq "body"){
			
			#---BodyBoundaryF
			$next_flag = "0";
			if (substr($msg,0,2) eq "--"){
				
				#---lXgAKwF킹čs
				foreach $a (@now_boundary){
					if ($a ne "" && ($msg eq "--$a\n" || $msg eq "--$a--\n")){
						
						if ($a ne $now_boundary[$now_bcnt]){ $now_bcnt--;}
						$body_head[$now_bcnt] = "header";
						$body_cnt [$now_bcnt]++;
						
						$now_pnt = "";
						foreach $b (0.. $now_bcnt){
							$b = $body_cnt[$b];
							if ($b ne ""){
								if    ($b > 99){ $now_pnt .=      $b."-";}
								elsif ($b >  9){ $now_pnt .= "0" .$b."-";}
								else           { $now_pnt .= "00".$b."-";}
							}
						}
						$now_pnt = substr($now_pnt,0,length($now_pnt)-1);
						
						#---ϐ
						$flag = "";
						$content_type = "";
						$content_id   = "";
						$content_enc  = "";
						$boundary2    = "";
						$name         = "";
						
						$name_flag   = "";
						$header_flag = "";
						$next_flag   = "1";
					}
				}
			}
			
			if ($next_flag eq "1"){ next;}
			
			#---VOp[giój
			if ($body_cnt[0] == 0){ &main::jcode'convert(*msg,lc($mojicode));
			                        $output_body{"000"} .= $msg;
			                        $output_list{"000"}  = "text"; }
			if ($body_cnt[0] >  0){
				
				#---wb_[EF
				if ($msg eq "\n"){ $body_head[$now_bcnt] = "body";}
				
				#---}`p[gwb_[
				if ($body_head[$now_bcnt] eq "header"){
					
					if ($now_pnt eq $pnt_no){
						
						if ($script_h ne ""){
							
							&$script_h(*msg);
							
						}else{
							
							chomp $msg;
							
							#---wb_[ MIME Decode R[hEUC
							$msg = &main::mimedecode($msg,$mojicode);
							
							if    ($msg =~ /^content-type:/i             ){ @item = split(/;/,substr($msg,14));
							                                                $output_optdata{"content_type"} = $item[0];       }
							elsif ($msg =~ /^content-id:/i               ){ $output_optdata{"content_id"  } = substr($msg,12);
							                                                $output_optdata{"content_id"  } =~ s/^<//;
							                                                $output_optdata{"content_id"  } =~ s/>$//;
							                                                                                                  }
							elsif ($msg =~ /^content-transfer-encoding:/i){ $output_optdata{"content_enc" } = substr($msg,27);}
							
							
							#---sΉNamemF
							if    ($name_flag ne ""){ ($name) = $msg =~ /^([^"]+)/;
							                           $output_optdata{"content_name"} .= $name if $name ne "";
							                           if ($msg =~ /\"/){ $name_flag = "";}
							                           else             { next;           }
							                                                                                }
							if    ($msg =~ /name=/i){ if   (($name) = $msg =~ /name\s*=\s*\"([^"]+)\"/i){                   }
								                        elsif(($name) = $msg =~ /name\s*=\s*\"([^"]+)/i  ){ $name_flag = "\"";}
								                        else                                              { 
							                               ($name) = $msg =~ /name\s*=\s*([^\s\t]+)/i;
							                          }
							                          $output_optdata{"content_name"} = $name;
							                                                                                                   }

						}
						
					}else{
						
						chomp $msg;
						
						#---wb_[ MIME Decode R[hEUC
						$msg = &main::mimedecode($msg, $mojicode);
						
						if    ($msg =~ /^content-type/i){ $content_type = substr($msg,14); }
					
						if    ($msg =~ /boundary=/i){ ($boundary2) = $msg =~ /boundary\s*=\s*"([^"]+)"/io;
						                              ($boundary2) = $msg =~ /boundary\s*=\s*([$ascii]+)/io unless $boundary2;

							                            $now_bcnt++;
							                            $now_boundary[$now_bcnt] = $boundary2;
						                                                                                                      }
					}
				}
				
				#---}`p[g{fB[
				if ($body_head[$now_bcnt] eq "body"){
					
					#---ds֎~tO
					if ($flag eq ""){
						
						if ($content_type =~ /^message\/rfc/i){ $body_head[$now_bcnt]   = "header";
						                                        $header_flag = "";
						                                                                             }
						$flag = "1";
						next;
					}
					
					#---[eB֓n
					
					if ($now_pnt eq $pnt_no){
						if   ($script_b ne ""){ &$script_b             (\$buf,*output_optdata);}
						else                  { &default_getfile_script(\$buf,*output_optdata);}
					}
				}
			}
		}
	}
	
	$msg = &imap4_rc();
	if (substr($msg,0,1) eq ")"){
		$msg = &imap4_rc();
	}
	while(substr($msg,0,1) eq "*"){
		$msg = &imap4_rc();
	}
	if (substr($msg,0,4) ne "0000" || substr($msg,5,2) ne "OK"){
		return('imap4getfile','fetch','Finish Read'."\n".substr($msg,5));
	}
	
	
	return(1,*output_filedata);
}

#---ftHgt@CǂݎXNvg
sub default_getfile_script{
	
	$pnt1 = $_[0];
	$pnt2 = $_[1];
	
	#---t@C^CvF
	if ($d_flag eq ""){
		$output_filedata{"content_id"  } = $$pnt2{"content_id"  };
		$output_filedata{"content_enc" } = $$pnt2{"content_enc" };
		$output_filedata{"content_type"} = $$pnt2{"content_type"};
		$output_filedata{"content_name"} = $$pnt2{"content_name"};
		
		$d_flag   = "1";
		$enc_type = "";
		
		if   ($auto_enc ne "1"                  ){ $enc_type = ""   ;}
		elsif($$pnt2{"content_enc"} =~ /quoted/i){ $enc_type = "qp" ;}
		elsif($$pnt2{"content_enc"} =~ /base64/i){ $enc_type = "b64";}
		else                                     { $enc_type = ""   ;}
	}
	
	#---I[gGR[h
	if ($enc_type ne ""){ $$pnt1 = &main::bodydecode($$pnt1,$enc_type); }
	
	#---o
	$output_filedata{"content_body"} .= $$pnt1;
	
}

