#-------------------------------------------------------------------------------------------------------
# [{bNXc[ꗗ
# &imap4gettree(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           mojicode -- sjis/euc   
#
# Output: 1,@<TreeName>    ,%<TreeStatus>
#           => <ID>,<Name>    => <ID>-child  -- [1=SubFolder|0=NoSubFolder  ]
#                                <ID>-mark   -- [1=V |0=VȂ     ]
#                                <ID>-select -- [1=I\ |0=Is\   ]
#                                <ID>-maked  -- [1=TutH_|0=s]
#                                <ID>-unseen -- ǃbZ[W
#                                <ID>-recent -- VbZ[W
#                                <ID>-message-- bZ[W
#                                <ID>-delimit-- Kw؂蕶
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4gettree{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	$mojicode = $lib_pointer{"mojicode"};
	$scanmode = $lib_pointer{"scanmode"};
	($inbox,$inboxname) = split(/\0/,$lib_pointer{"inbox"});
	$inbox = $inboxname = "INBOX" if $inbox eq "";
	
	#---ڑmF
	if($login_ctl{"imap"} != 1 ){ return('imap4gettree','notlogin','IMAP4'); }
	
	@out_tree = ();
	@in_tree  = ();
	%tree_hash= ();
	@tree_item= ();
	
	#---c[擾
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError: LIST Command";}
	&imap4_tr('0000 LIST "" "*"'."\r\n");
	$cnt = 0;
	
	#---alarm~߂
	if ($timeout_time ne ""){ alarm(0);}
	while(1){
		$rc = &imap4_rc();
		if (substr($rc,0,4) eq "0000"){ last;}
		
		$rc =~ tr/\r//d;
		if ($rc =~ /\* LIST \(([^\)]+)\) NIL \"*([^\"]+)\"*/){
			$flag    = $1;
			$delimit = "";
			$name    = $2;
			$name    =~ tr/\n//d;
		}else{
			($flag,$delimit,$size) = $rc =~ /\* LIST \(([^\)]+)\) \"([^\"]+)\" \{(\d+)\}\n/;
			if ($size ne ""){
				$rc = &imap4_rc();
				$name = substr($rc,0,$size);
			}else{
				$rc =~ tr/\n//d;
				($flag,$delimit,$name) = $rc =~ /\* LIST \(([^\)]+)\) \"([^\"]+)\" \"*([^\"]+)\"*/;
			}
		}
		if (substr($name,0,1) eq "."){ next;}
		
		if ($flag =~ /\\Noinferiors/i  ){ $tree_hash{$cnt."-maked" } = 0;}
		else                            { $tree_hash{$cnt."-maked" } = 1;}
		if ($flag =~ /\\Noselect/i     ){ $tree_hash{$cnt."-select"} = 0;}
		else                            { $tree_hash{$cnt."-select"} = 1;}
		if ($flag =~ /\\Marked/i       ){ $tree_hash{$cnt."-mark"  } = 1;}
		if ($flag =~ /\\Unmarked/i     ){ $tree_hash{$cnt."-mark"  } = 0;}
		if ($flag =~ /\\HasChildren/i  ){ $tree_hash{$cnt."-child" } = 1;}
		if ($flag =~ /\\HasNoChildren/i){ $tree_hash{$cnt."-child" } = 0;}
		
		$name    =~ s/\\\\/\\/g;
		$delimit =~ s/\\\\/\\/g;
		$tree_hash{$cnt."-name"   } = $name;
		$tree_hash{$cnt."-delimit"} = $delimit;
		push(@tree_item,$cnt);
		
		$name =~ s/\Q$delimit\E/\0/g if $delimit ne "";
		
		&main'imap_utf_d(*name,$mojicode);
		
		if (index($name,$inbox) == 0){
			$name =~ s/^$inbox/$inboxname/i;
			push(@in_tree ,$cnt."\0".$name);
		}else{
			push(@out_tree,$cnt."\0".$name);
		}
		$cnt++;
	}
	if (substr($rc,0,7) ne "0000 OK"){ return('imap4gettree','list',$rc);}
	unshift(@out_tree,@in_tree);
	
	if ($scanmode eq "N"){ return(1,*out_tree,*tree_hash);}
	
	foreach $a (@tree_item){
		$tmp = $tree_hash{$a."-name"};
		
		#---FastScan̏ꍇINBOXׂȂ
		if (($scanmode eq "1" || $scanmode eq "0" || $scanmode eq "") && $tmp ne $inbox){ next;}
		
		if ($scanmode eq "2" || $scanmode eq "0" || $scanmode eq ""){
			#---Xe[^X擾
			$tmp =~ s/\\/\\\\/g;
			($com,$rc) = &imap4_com('STATUS "'.$tmp.'" (RECENT UNSEEN MESSAGES)');
			if (substr($com,0,2) ne "OK"){ next;}
			
			($recent ) = $rc =~ /RECENT (\d+)/i;
			($message) = $rc =~ /MESSAGES (\d+)/i;
			($unseen ) = $rc =~ /UNSEEN (\d+)/i;
		}else{
			#---[{bNXI
			$unseen = 0;
			($rc,$recent,$message) = &execute('imap4select',$tmp);
			if ($rc ne "1"){ return('imap4gettree','select',$recent."\n".$message);}
			if ($message != 0){
				($com,$rc) = &imap4_com('SEARCH UNSEEN');
				if (substr($com,0,2) ne "OK"){ return('imap4gettree','search',$rc."\n".$com);}
				$unseen  = $rc =~ tr/ //;
			}
		}
		
		$tree_hash{$a."-recent" } = $recent;
		$tree_hash{$a."-message"} = $message;
		$tree_hash{$a."-unseen" } = $unseen;
	}
	
	return(1,*out_tree,*tree_hash);
}


