
#-------------------------------------------------------------------------------------------------------
# [{bNXړ
# &imap4movebox(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           mailbox1 -- Original   imap_server   --- IMAP Server
#           mailbox2 -- Target     imap_port     --- IMAP Port
#                                  imap_account  --- IMAP Account
#                                  imap_password --- IMAP Password
#                                  imap_ssl      --- IMAP over SSL (ssl|"")
#
# Output: 1
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4movebox{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	$mailbox1 = $lib_pointer{"mailbox1"};
	$mailbox2 = $lib_pointer{"mailbox2"};
	
	#---ڑmF
	if($login_ctl{"imap"} != 1 ){ return('imap4movebox','notlogin','IMAP4'); }
	
	#---؂F
	($rc,$flag,$delimit,$name) = &execute('imap4getdelimit',$mailbox1);
	if ($rc ne "1"){ return('imap4movebox->'.$rc,$flag,$delimit);}
	
	#---ړ挈
	@item = split(/\Q$delimit\E/,$mailbox1);
	$mailbox2 .= $delimit if $mailbox2 ne "";
	$mailbox2 .= pop(@item);
	
	if (index($mailbox2,$mailbox1) == 0){
		return('imap4movebox','badmove',$mailbox1."->".$mailbox2);
	}
	
	#---ړJn
	$mailbox2 =~ s/\\\\/\\/g;
	$mailbox2 =~ s/\\/\\\\/g;
	$mailbox1 =~ s/\\\\/\\/g;
	$mailbox1 =~ s/\\/\\\\/g;
	($rc,$com) = &imap4_com("RENAME \"$mailbox1\" \"$mailbox2\"");
	if (substr($rc,0,2) ne "OK"){ return('imap4movebox','rename',$mailbox1."->".$mailbox2);}
	
	
	return(1);
	
}
