#-------------------------------------------------------------------------------------------------------
# MTAΉW[M
# &mxsendmail(<Pointer>,<ConfigPointer>);
# 
# Input: <Pointer> HashPointer                               <ConfigPointer> HashPointer
#         => from        -- From                               => nslookup_path-- nslookup̃pX(^^;
#            to          -- To (J}؂蕡w)           smtp_temp    -- e|pX
#            cc          -- CC                                    dns_addr     -- DNS IP Address
#            bcc         -- BCC                                   
#            subject     -- Subject                               
#            date        -- Date                                  
#            reply-to    -- Reply-To                              
#            in-reply-to -- In-Reply-To                           
#            references  -- References                            
#            other_head  -- AddHeader                             
#            message     -- Message                    
#            mailbox     -- MailBox      (IMAP4p)
#            rcpt        -- MAhX
#            sender      -- MAIL Fromp[AhX
#            selfaddr    -- [ȃ[AhX]
#
#            sendfile    -- <HashPointer>
#                           filename1[:content_type] => DATA1,
#                           filename2[:content_type] => DATA2,
#                           ,
#                           ,
#            
#            foward      -- tH[h[
#
# ȃ[AhXɃ[AhXw肷ƁA
#   ̃AhXɂAMeM
#
# Output: ArrayPointer
# => <Status[OK or Error]>:<SendAddress>:<RcMessage>
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub mxsendmail{
	
	#---e|C^擾
	(*lib_pointer,*lib_config) = @_;
	
	#---eϐ擾
	$mail_from   = $lib_pointer{"from"       };
	$mail_to     = $lib_pointer{"to"         };
	$mail_cc     = $lib_pointer{"cc"         };
	$mail_bcc    = $lib_pointer{"bcc"        };
	$mail_subj   = $lib_pointer{"subject"    };
	$mail_reply  = $lib_pointer{"reply-to"   };
	$mail_date   = $lib_pointer{"date"       };
	$mail_repl   = $lib_pointer{"in-reply-to"};
	$mail_ref    = $lib_pointer{"references" };
	$mail_head   = $lib_pointer{"other_head" };
	$mail_body   = $lib_pointer{"message"    };
	*mail_file   = $lib_pointer{"sendfile"   };
	$mail_fow    = $lib_pointer{"foward"     };
	$mail_sender = $lib_pointer{"sender"     };
	$mail_self   = $lib_pointer{"selfaddr"   };
	$mail_rcpt   = $lib_pointer{"rcpt"       };
	$mail_box    = $lib_pointer{"mailbox"    };
	$con_type    = $lib_pointer{"mode"       };
	$mail_into   = $lib_pointer{"into"       };
	$mailsign_str= $lib_pointer{"mailsign"   };
	
	$nslookup_path = $lib_config{"nslookup"    };
	$dns_address   = $lib_config{"dns_address" };
	$sendmail_path = $lib_config{"sendmail"    };
	$use_sendmail  = $lib_config{"use_sendmail"};
	$end_dot       = $lib_config{"end_dot"     };
	
	#---ϐ
	@file_list        = keys(%mail_file);
	@sendtarget_list  = ();
	
	#---Content-TypeF
	if ($mail_fow ne "" || $#file_list != -1 ){ #-----boundary̍쐬
		                                          $boundary_data = localtime;
		                                          $boundary_data =~ tr/ :/__/d;
		                                          $boundary_data = "--NEXT_PART_$boundary_data==";
		
		                                          $content_type = "Multipart/Mixed\; boundary=\"$boundary_data\"";}
	else                                      { $content_type = "text/plain\; charset=iso-2022-jp";             }
	
	
	#---Mt@CL^Jn
	$rfc822_img = "";
	
	#---alarm~߂
	if ($timeout_time ne ""){ alarm(0);}
	
	#---M摗M
	if ($mail_rcpt ne ""){ $mail_to2 = $mail_rcpt;}
	else                 { $mail_to2 = $mail_to  ;}
	foreach $lib_a (split(/,/,$mail_to2.",".$mail_cc.",".$mail_bcc)){
		
		if ($lib_a !~ /[0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+/o){ next;}
		
		($send) = $lib_a =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
		
		push(@sendtarget_list,$send);
	}
	if ($mail_self ne ""){ 
		push(@sendtarget_list,$mail_self);
	}
	
	#---To/Cc/Bcc`
	$mail_cc    =~ s/,+$//;
	$mail_cc    =~ s/,/,\r\n    /g;
	$mail_bcc   =~ s/,+$//;
	$mail_bcc   =~ s/,/,\r\n    /g;
	$mail_to    =~ s/,+$//;
	$mail_to    =~ s/,/,\r\n    /g;
	$mail_reply =~ s/,+$//;
	$mail_reply =~ s/,/,\r\n    /g;
	
	
	#-----------------------------{M-------------------------------#
	
	#---wb_[쐬
	$header  = "From: $mail_from\n";
	$header .= "To: $mail_to\n";
	$header .= "Subject: $mail_subj\n";
	$header .= "Mime-Version: 1.0\n";
	$header .= "Content-type: $content_type\n";
	$header .= "Content-Transfer-Encoding: 7bit\n";
	
	#---ǉwb_[
	if ($mail_date  eq ""){ $send_date = &mailcontrol_getdate();
	                        $header .= "Date: $send_date\n";
	                                                               }
	else                  { $header .= "Date: $mail_date\n";       }
	if ($mail_cc    ne ""){ $header .= "Cc: $mail_cc\n";           }
	if ($mail_reply ne ""){ $header .= "Reply-To: $mail_reply\n";  }
#	if ($mail_bcc   ne ""){ $header .= "Bcc: $mail_bcc\n";         }
	if ($mail_repl  ne ""){ $header .= "In-Reply-To: $mail_repl\n";}
	if ($mail_ref   ne ""){ $header .= "References: $mail_ref\n";  }
	
#	$header .= "$mail_head";
	
#	$header =~ s/\r\n\r\n/\r\n/g;
#	$header =~ s/(\r\n)$//;
	
	&main::jcode'convert(*header,"jis");
	$header = &main::mimeencode($header);
	$header =~ s/\n/\r\n/g;
	$rfc822_img .=$header."\r\n";
	
	#---}`p[g
	if ($boundary_data ne ""){ $header2  = "--$boundary_data\r\n";
	                           $header2 .= "Content-Type: text/plain; ";
	                           $header2 .= "charset=\"iso-2022-jp\"\r\n";
	                           $header2 .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
	                           $rfc822_img .=$header2;
	                                                                                 }
	
	#---Body
	$mail_body    =~ tr/\r//d;
	$mailsign_str =~ tr/\r//d;
	&main::jcode'convert(*mail_body,"jis");
	&main::jcode'convert(*mailsign_str,"jis");
	foreach $lib_c (split(/\n/,$mail_body."\n".$mailsign_str)){
		$lib_c .= "\r\n";
		if ($lib_c =~ /^\.+\r\n/ && $mail_into eq ""){ $rfc822_img .= ".".$lib_c;}
		else                                         { $rfc822_img .= $lib_c;    }
	}
	$rfc822_img .= "\r\n";
	
	#-------------------------tH[hM----------------------------#
	
	if ($mail_fow ne ""){
		
		$header2  = "--$boundary_data\r\n";
		$header2 .= "Content-Type: message/rfc822\r\n";
		$header2 .= "Content-Description: FwMail\r\n\r\n";
		$rfc822_img .=$header2;
		
		if ($con_type eq "imap" && $mail_box ne ""){
			
			#---IMAP4T[o[ڑ
			($rc,$type,$msg) = &execute("imap4login","",*lib_config);
			if ($rc ne "1"){ &execute("imap4logout");
			                return('mxsendmail->'.$rc,$type,$msg);}
			
			#---[{bNXI
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: SELECT Command";}
			($rc,$com) = &imap4_com("SELECT \"$mail_box\"");

			if (substr($rc,0,2) ne "OK"){ &execute("imap4logout");
			                              return('mxsendmail','select',$rc."\n".$com);}
			
			&imap4_tr("0000 FETCH ".$mail_fow." RFC822\r\n");
			$msg = &imap4_rc();
			if (substr($msg,0,4) eq "0000"){ &execute("imap4logout");
			                                 return('mxsendmail','fetch',$msg);}
			($total_size) = $msg =~ /\{(\d+)\}/;
			$nowsize=0;
			
			while(1){
				if ($nowsize >= $total_size){ last;}
				$buf = &imap4_rc();
				$nowsize += length($buf);
				
				$buf  =~ tr/\r\n//d;
				$buf .= "\r\n";
				if ($buf =~ /^\.+\n/ && $mail_into eq ""){ $rfc822_img .= ".".$buf;}
				else                                     { $rfc822_img .= $buf;    }
			}

			$msg = &imap4_rc();
			if (substr($msg,0,1) eq ")"){
				$msg = &imap4_rc();
			}
			while(substr($msg,0,1) eq "*"){
				$msg = &imap4_rc();
			}
			if (substr($msg,0,4) ne "0000" || substr($msg,5,2) ne "OK"){
				return('mxsendmail','fetch','Finish Read'."\n".substr($msg,5));
			}
			
			&execute("imap4logout");
			
		}elsif($con_type ne "imap"){

			#---POP3T[o[ڑ
			($rc,$type,$msg) = &execute("pop3login","",*lib_config);
			if ($rc ne "1"){ &execute("pop3logout");
			                 return('mxsendmail->'.$rc,$type,$msg);}
			
			#---[M
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: RETR Command";}
			&pop3_tr("RETR $mail_fow\r\n");
			$rc = &pop3_rc();
			if( $rc !~ /\+OK/ ) { &execute("pop3logout");
			                      return('mxsendmail','retr',$rc);                }
			
			if ($timeout_time ne ""){ alarm(0);}
			
			while(1){
				$buf = &pop3_rc();
				if( $buf =~ /^\.\r\n/ ) { last; }
				$rfc822_img .=$buf;
			}
			
			&execute("pop3logout");
		}
	}
	
	
	#-------------------------t@CM----------------------------#
	if ($#file_list != -1){
		
		foreach $lib_a (keys(%mail_file)){
			
			($name,$type) = split(/:/,$lib_a);
			
			#---Content-TypeF
			if ($type eq ""){ ($type_data) = $name =~ /\.(\w+)$/;
			                  $type_data =~ tr/A-Z/a-z/;
			                  $type = $kakutyousi{$type_data};
			                                                     }
			if ($type eq ""){ $type = "application/octet-stream";}

			&main::jcode'convert(*name,"jis");
			$name = &main::mimeencode($name);
			
			#---wb_[M
			$header2  = "--$boundary_data\r\n";
			$header2 .= "Content-Type: $type\; name=\"$name\"\r\n";
			$header2 .= "Content-Disposition: attachment\; filename=\"$name\"\r\n";
			$header2 .= "Content-Transfer-Encoding: base64\r\n\r\n";
			
			&main::jcode'convert(*header2,"jis");
			$rfc822_img .=$header2;
			
			#---{fBM
			$rfc822_img .=&main::bodyencode($mail_file{$lib_a});
			$rfc822_img .=&main::benflush();
			
			$rfc822_img .="\r\n";
			
		}
		
	}
	
	#---I
	if ($boundary_data ne ""){ $rfc822_img .="--$boundary_data--\r\n\r\n";}
	
	$rfc822_img .=".\r\n" if $mail_into eq "";
	
	
	#---MM
	($mail_addr) = $mail_from =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
	if ($mail_addr eq ""  ){ $mail_addr = "localhost\@localdomain";}
	if ($mail_sender ne ""){ $mail_addr = $mail_sender;            }
	
	if ($mail_into eq ""){
		if ($use_sendmail ne ""){ ($rc,$type,$msg) = &execute('send_sendmail',$mail_addr,*sendtarget_list,$sendmail_path,*rfc822_img,$end_dot);    }
		else                    { ($rc,$type,$msg) = &execute('send_mta'     ,$mail_addr,*sendtarget_list,$nslookup_path,$dns_address,*rfc822_img);}
		if ($rc ne "1"){ return('mxsendmail->'.$rc,$type,$msg);}
		*output_send_list = $type;
		
		if (@sendtarget_list == 0){
			return('mxsendmail','nosendfrom');
		}
		
		return (1,*output_send_list);
	}else{
		
		$lib_pointer{"msg_data" } = $rfc822_img;
		$lib_pointer{"add_id"   } = "1";
		$lib_pointer{"mail_addr"} = $mail_addr;
		($rc,$type,$msg) = &execute('imap4append',*lib_pointer,*lib_config);
		if ($rc ne "1"){ return('mxsendmail->'.$rc,$type,$msg);}
		
		@output_send_list = ("OK"."\0".$type);
		return(1,*output_send_list);
	}
	
}
