
#-------------------------------------------------------------------------------#
#               WebMailClientW[|[U[ݒ葀                   #
#                                                                               #
# Copyright 2002                                                                #
# ---LunarNight Lab.---                                                         #
# lunar-night@ninus.ocn.ne.jp                                                   #
# http://www.age.jp/~lunar/                                                     #
#-------------------------------------------------------------------------------#

#---f[^z
@data_array = ('name:j'     ,'mail',
               'mail_serv'  ,'user'  ,'pass','mail_port','prot_type','over_ssl:s','smtp_ssl:s',
               'smtp_serv:s','smtp_port:s','smtp_type:s','smtp_mode' ,
               'sendcopy:s' ,
               'b_serv:s'   ,'b_name:s' ,'b_port:s' ,'b_pass:s' ,'b_opt:s',
               'sieve_serv:s' ,'sieve_port:s','sieve_ssl:s');

return 1;

sub faccount_ctl{
	
	($mode,@opt) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	if   ($mode eq "ac_list" ){ return(&faccount_aclist  (@opt));}
	elsif($mode eq "ac_get"  ){ return(&faccount_acget   (@opt));}
	elsif($mode eq "ac_add"  ){ return(&faccount_acadd   (@opt));}
	elsif($mode eq "ac_del"  ){ return(&faccount_acdel   (@opt));}
	elsif($mode eq "ac_up"   ){ return(&faccount_acup    (@opt));}
	elsif($mode eq "ac_dn"   ){ return(&faccount_acdn    (@opt));}
	elsif($mode eq "getsign" ){ return(&faccount_getsign (@opt));}
	elsif($mode eq "setsign" ){ return(&faccount_setsign (@opt));}
	elsif($mode eq "chkaddr" ){ return(&faccount_chkaddr ());    }
	else                      { return('ERROR:faccount_ctl:sȃR}hł:'.$mode);}
}

#---AhXp
sub faccount_chkaddr{
	return("0");
}

#---AJEgړ
sub faccount_acdn{
	
	($dummy,$ac_cnt) = @_;
	
	#---ϐ
	$session_str = $cookie{"wm_session"};
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	if ($rc ne "1"){ return('ERROR:Ɏs܂');}
	
	$str = "";
	$str2= "";
	$cnt = 1;
	
	foreach $a (split(/\n/,$dec)){
		if ($cnt == $ac_cnt    ){ $str   = $a."\n";                           $cnt++; next;}
		if ($cnt == $ac_cnt + 1){ $str2 .= $a."\n"; $str2 .= $str; $str = ""; $cnt++; next;}
		$str2 .= $a."\n";
		$cnt++;
	}
	$str2 .= $str if $str ne "";
	
	($rc,$enc) = &encrypt('encrypt',$str2,'b64');
	$out_cookie{"wm_session"} = $enc;
	$cookie    {"wm_session"} = $enc;
	$exp_cookie{"wm_session"} = &execute('expires',$save_day) if $save_f ne "";
	
	return(1);
}

#---AJEgړ
sub faccount_acup{
	
	($dummy,$ac_cnt) = @_;
	
	#---ϐ
	$session_str = $cookie{"wm_session"};
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	if ($rc ne "1"){ return('ERROR:Ɏs܂');}
	
	#---G[`FbN
	if ($ac_cnt == 1){ return(1);}
	
	$str = "";
	$str2= "";
	$cnt = 1;
	
	foreach $a (split(/\n/,$dec)){
		if ($cnt == $ac_cnt - 1){ $str   = $a."\n";                           $cnt++; next;}
		if ($cnt == $ac_cnt    ){ $str2 .= $a."\n"; $str2 .= $str; $str = ""; $cnt++; next;}
		$str2 .= $a."\n";
		$cnt++;
	}
	$str2 .= $str if $str ne "";
	
	($rc,$enc) = &encrypt('encrypt',$str2,'b64');
	$out_cookie{"wm_session"} = $enc;
	$cookie    {"wm_session"} = $enc;
	$exp_cookie{"wm_session"} = &execute('expires',$save_day) if $save_f ne "";
	
	return(1);
	
}

#---ݒ
sub faccount_setsign{
	
	($dummy,$ac_cnt,$sign) = @_;
	
	$dstr  = $user_info{"mail_serv"};
	$dstr .= $user_info{"user"};
	$dstr .= $user_info{"pass"};
	$dstr  = &md5::convert($dstr);
	
	$sign_str = $cookie{"wm_sign"};
	$sign     =~ tr/\r//d;
	$sign     =~ tr/\n/\0/d;
	
	$out_str  = "";
	$sflag    = "";
	($rc,$dec) = &encrypt('decrypt',$sign_str,'b64');
	foreach $a (split(/\n/,$dec)){
		($md5) = split(/\0/,$a);
		if ($md5 eq $dstr){ $out_str .= $md5."\0".$sign."\n"; $sflag = "1";}
		else              { $out_str .= $a."\n";                           }
	}
	if ($sflag ne "1"){ $out_str .= $dstr."\0".$sign."\n";}
	
	($rc,$sign2) = &encrypt('encrypt',$out_str,'b64');
	$out_cookie{"wm_sign"} = $sign2;
	$cookie    {"wm_sign"} = $sign2;
	$exp_cookie{"wm_sign"} = &execute('expires',$save_day) if $save_f ne "";
#	$exp_cookie{"wm_sign"} = &execute('expires',$save_day);
	
	return(1);
	
}

#---擾
sub faccount_getsign{
	
	($auth_user,$ac_cnt) = @_;
	
	$dstr  = $user_info{"mail_serv"};
	$dstr .= $user_info{"user"};
	$dstr .= $user_info{"pass"};
	$dstr  = &md5::convert($dstr);
	
	$sign_str = $cookie{"wm_sign"};
	($rc,$dec) = &encrypt('decrypt',$sign_str,'b64');
	
	$sign  = "";
	foreach $a (split(/\n/,$dec)){
		($md5,@dat) = split(/\0/,$a);
		if ($md5 eq $dstr){ $sign = join("\n",@dat); last;}
	}
	
	return(1,$sign);
	
}

#---AJEg擾
sub faccount_acget{
	($dummy,$ac_cnt) = @_;
	
	#---ϐ
	$session_str = $cookie{"wm_session"};
	%user_info   = ();
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	if ($rc ne "1"){ return('ERROR:Ɏs܂');}
	
	$cnt=1;
	$f  =0;
	foreach $a (split(/\n/,$dec)){
		if ($cnt == $ac_cnt){
			
			#---f[^i[
			@item = split(/\0/,$a);
			$user_info{'ac_name'} = shift(@item);
			foreach $a (@data_array){
				($key,$opt) = split(/:/,$a);
				$user_info{$key} = shift(@item);
			}
			$f = 1;
			last;
		}
		$cnt++;
	}
	
	if ($f == 0){ return('ERROR:AJEg񂪑݂Ȃ܂͕Ɏs܂');}
	
	return(1,*user_info);
}

#---AJEg폜
sub faccount_acdel{
	($dummy,$ac_cnt) = @_;
	
	#---ϐ
	$session_str = $cookie{"wm_session"};
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	if ($rc ne "1"){ return('ERROR:Ɏs܂');}
	
	$cnt     =1;
	$out_str = "";
	$delinfo = "";
	foreach $a (split(/\n/,$dec)){
		if ($cnt == $ac_cnt){ $delinfo = $a; $ac_name = (split(/\0/,$a))[0]; $cnt++; next;}
		$out_str .= $a."\n";
		$cnt++;
	}
	
	($rc,$enc) = &encrypt('encrypt',$out_str,'b64');
	$out_cookie{"wm_session"} = $enc;
	$cookie    {"wm_session"} = $enc;
	$exp_cookie{"wm_session"} = &execute('expires',$save_day) if $save_f ne "";
	
	if ($delinfo ne ""){
		%user_info = ();
		@item = split(/\0/,$delinfo);
		$user_info{'ac_name'} = shift(@item);
		foreach $a (@data_array){
			($key,$opt) = split(/:/,$a);
			$user_info{$key} = shift(@item);
		}
		&faccount_delsign();
	}
	
	&execute('writelog','del_ac',"Mail=$tmp_mail Name=$tmp_name AC_NAME=$ac_name FreeAccess");
	return(1);
}

#---폜
sub faccount_delsign{
	
	$dstr  = $user_info{"mail_serv"};
	$dstr .= $user_info{"user"};
	$dstr .= $user_info{"pass"};
	$dstr  = &md5::convert($dstr);
	
	$sign_str = $cookie{"wm_sign"};
	($rc,$dec) = &encrypt('decrypt',$sign_str,'b64');
	
	$sign_str = "";
	foreach $a (split(/\n/,$dec)){
		($md5) = split(/\0/,$a);
		if ($md5 eq $dstr){ next;}
		$sign_str .= $a."\n";
	}
	
	($rc,$enc) = &encrypt('encrypt',$sign_str,'b64');
	$out_cookie{"wm_sign"} = $enc;
	$cookie    {"wm_sign"} = $enc;
	$exp_cookie{"wm_sign"} = &execute('expires',$save_day) if $save_f ne "";
	
	return(1);
}

#---AJEgǉ
sub faccount_acadd{

	#---ϐ
	$session_str = $cookie{"wm_session"};
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	
	#---f[^Zbg
	$tmp_data  = "";
	$err_opt   = "";
	$mx_mode   = "";
	$log_str   = "";
	foreach $a (@data_array){
		
		($val,$opt) = split(/:/,$a);
		
		$err_opt .= $val."," if $opt ne "s" && $in{$val} eq "" && $opt ne "j";
		$mx_mode  = $in{$val} if $val eq "use_mx";
		
		if ($opt eq "j"){ $tmp = $in{$val};
		                  &jcode'convert(*tmp,"sjis");
		                  $in{$val} = $tmp;           }
		
		$tmp_data       .= $in{$val}."\0";
		$log_str        .= $val."=".$in{$val}." " if $in{$val} ne "" && $val ne "pass";
	}
	$ac_name  = $in{'ac_name'};
	&jcode'convert(*ac_name,'sjis');
	
	if ($err_opt ne ""         ){ return('ERROR:͍ڂ܂:'.$err_opt);}
	if ($mx_mode eq "1"      &&
	    $nslookup_path eq "" &&
	    $dsn_address   eq ""   ){ return('ERROR:ȈMTA@\𗘗pɂnslookuppX܂DNST[o[w肷Kv܂(^^;');}
	
	($rc,$enc) = &encrypt('encrypt',$dec.$ac_name."\0".$tmp_data."\0\n",'b64');
	
	#---ZbVۑ
	$cookie    {"wm_session"} = $enc;
	$out_cookie{"wm_session"} = $enc;
	$exp_cookie{"wm_session"} = &execute('expires',$save_day) if $save_f ne "";
	
	&execute('writelog','add_ac',"Mail=$tmp_mail Name=$tmp_name FreeAccess ".$log_str." pass=XXXXXXXX");
	
	return(1);
}


#---AJEgXg
sub faccount_aclist{
	
	#---ϐ
	$session_str = $cookie{"wm_session"};
	@out_aclist = ();
	
	#---Jn
	($rc,$dec) = &encrypt('decrypt',$session_str,'b64');
	
	$cnt=1;
	foreach $a (split(/\n/,$dec)){
		if ($a eq ""){ next;}
		($acname) = split(/\0/,$a);
		push(@out_aclist,$cnt."\0".$acname);
		$cnt++;
	}
	
	return(1,*out_aclist);
}


