
#-------------------------------------------------------------------------------#
#               WebMailClientW[|e|                     #
#                                                                               #
# Copyright 2002                                                                #
# ---LunarNight Lab.---                                                         #
# lunar-night@ninus.ocn.ne.jp                                                   #
# http://www.age.jp/~lunar/                                                     #
#-------------------------------------------------------------------------------#

return 1;

sub settemp{
	
	($mode,@opt) = @_;
	
	if   ($mode eq "set"){ ($rc,$res) = &settemp_set(@opt);                }
	elsif($mode eq "get"){ ($rc,$res) = &settemp_get(@opt);                }
	else                 { ($rc)      = &error("command","settemp->$mode");}
	
	return($rc,$res);
	
}

sub settemp_get{
	
	($serial,$id) = @_;
	
	if(! -e $temp_path."/".$serial ){ return(&error("read",'ꎞۑt@C܂'));}
	
	%out_temphash = ();
	$flag         = 0;
	
	open(IN,"$temp_path/$serial");
	binmode IN;
	while(<IN>){
		
		if (substr($_,0,3) eq "key"){
			
			($key,$val) = $_ =~ /(\w+):([^\n]+)/;
			if ($val eq $id){ $flag = 1; next;}
		}
		
		if ($flag == 1){
			if ($_ eq "\n"){ last;}
			($key,$val) = $_ =~ /(\w+):([^\n]+)/;
			$out_temphash{$key} = $val;
		}
	}
	
	if ($flag != 1){ return(&error("no_data","temp->$serial->$id"));}
	
	read(IN,$tempdata_buf,$out_temphash{"len"});
	$out_temphash{"body"} = *tempdata_buf;
	
	close(IN);
	
	return(1,*out_temphash);
	
}

sub settemp_set{
	
	($serial,*input_l,*input_h,*input_b) = @_;
	
	if(! -e $temp_path."/".$serial ){ return(&error("read",'ꎞۑt@C܂'));}
	
	open(IN,">$temp_path/$serial");
	binmode IN;
	
	foreach $a (keys(%input_l)){
		if ($a eq ""){ next;}
		
		$c_type = $input_h{$a.":content_type"};
		$c_id   = $input_h{$a.":content_id"  };
		$c_name = $input_h{$a.":name"        };
		
		print IN "key:$a\n";
		print IN "id:$c_id\n";
		print IN "name:$c_name\n";
		print IN "type:$c_type\n";
		print IN "len:".length($input_b{$a})."\n";
		print IN "\n";
		print IN $input_b{$a}."\n";
	}
	
	close(IN);
	
	return(1);
}

