
#----------------------------------------------------------------------
#                   LunarNight Lab. Common Design Controller
#                   Ver 1.0
#
# LunarNight Laboratory
# lunar-night@ninus.ocn.ne.jp
# http://www.age.jp/~lunar/
#----------------------------------------------------------------------

package design_ctl;

$base_addr = "./lib/";

#---⥸塼Ͽ
%mld_hash = ('compile' => $base_addr.'design_ctl_sub/compile.pl' ,
             'set'     => $base_addr.'design_ctl_sub/set.pl'     ,
             'load'    => $base_addr.'design_ctl_sub/load.pl'    ,
             'exec'    => $base_addr.'design_ctl_sub/exec.pl'    ,
             'update'  => $base_addr.'design_ctl_sub/update.pl'  ,
             'generate'=> $base_addr.'design_ctl_sub/generate.pl',
             'chvalue' => $base_addr.'design_ctl_sub/chvalue.pl' );

%err_hash = ('no_module' => '⥸塼뤬Ĥޤ'          ,
             'read'      => 'ե뤬ɤ߹ޤ'            ,
             'write'     => 'ե뤬񤭹ޤ'            ,
             'compile'   => 'ѥ뼺'                      ,
             'design_err'=> 'ǥե顼'      ,
             'no_init'   => 'ȥ顼Ƥޤ',
             'no_command'=> 'ޥɤĤޤ'           );

$design_set = 0;

return 1;


#-------------------------------
#ƥᥤ
#-------------------------------
sub main::design_ctl{
	
	($mode,@opt_a) = @_;
	
	if   ($mode eq "set"     ){ ($res) = &execute("set"     ,@opt_a);   }
	elsif($mode eq "load"    ){ ($res) = &execute("load"    ,@opt_a);   }
	elsif($mode eq "exec"    ){ ($res) = &execute("exec"    ,@opt_a);   }
	elsif($mode eq "update"  ){ ($res) = &execute("update"  ,@opt_a);   }
	elsif($mode eq "generate"){ ($res) = &execute("generate",@opt_a);   }
	elsif($mode eq "chvalue" ){ ($res) = &execute("chvalue" ,@opt_a);   }
	else                      {  $res  = &error("no_command",$mode);    }
	
	if (substr($res,0,5) eq "ERROR" &&
	    $err_handle ne ""             ){ &$err_handle($err_argv,$res);}
	
	return($res);
}

#-------------------------------
#   ॹ׳ǧ, Ʊ=1 㤦=0
#-------------------------------
sub date_check{
	
	($target1,$target2) = @_;
	
	#---ץ׼
	$mtime1 = (stat($target1))[9];
	$mtime2 = (stat($target2))[9];
	
	if ($mtime1 <= $mtime2){ return (0);}
	else                   { return (1);}
	
}
#-------------------------------
#饤֥¹
#-------------------------------
sub load_lib{
	
	($exec_mld) = @_;
	
	if ($exec_hash{$exec_mld} != 1){ $msg = eval('require "'.$exec_mld.'";');
	                                 $exec_hash{$exec_mld} = 1;             }
	else                           { $msg = 1;                              }
	
	return($msg);
}



#-------------------------------
#⥸塼¹
#-------------------------------
sub execute{
	
	($exec_mld,@opt_mld) = @_;
	
	if   ($mld_hash{$exec_mld} ne "" &&
	      $exec_hash{$exec_mld} != 1   ){ require $mld_hash{$exec_mld};
	                                      $exec_hash{$exec_mld} = 1;            }
	elsif($exec_hash{$exec_mld} == 1   ){                                       }
	else                                { return(&error("no_module",$exec_mld));}
	
	return(&$exec_mld(@opt_mld));
}


#----------------------------------
#  顼
#----------------------------------
sub error{
	
	($mode,$err_msg1) = @_;
	
	if   ($err_msg1 eq "" ){ $err_msg0 = $mode;             }
	else                   { $err_msg0 = $err_hash{$mode};  }
	
	$err_msg0 =~ s/\n/<br>/g;
	$err_msg1 =~ s/\n/<br>/g;
	
	return("ERROR:$err_msg0:$err_msg1");
}


