
#------------------------------------------------------------------------------
#            ʰץǡ١饤֥
#------------------------------------------------------------------------------
#
# InputHash
#
# dbflag  -- ե饰
# dbmain  -- ᥤե
# dbsize  -- DB쥳ɥ
# cntsize -- 쥳ɺID(10^x)
#
#

use integer;
package minidb;

return 1;

sub put_data{
	
	($data,*db_dat_p) = @_;
	
	#---
	$dbflag  = $db_dat_p{"dbflag" };
	$dbmain  = $db_dat_p{"dbmain" };
	$dbsize  = $db_dat_p{"dbsize" };
	$cntsize = $db_dat_p{"cntsize"};

	#---ID
	$out_data = &get_empty($dbflag,$dbmain,$dbsize,$cntsize);
	
	if(-e $dbmain ){ $w_mode = "+<";}
	else           { $w_mode = ">" ;}
	
	&fill_space(*data,$dbsize);
	
	if (! open(IN2,$w_mode.$dbmain)){ return("ERROR:ե񤭹ߥ顼:minidb->put_data");}
	flock(IN2,2);
	
	binmode IN2;
	
	seek(IN2,$out_data*($dbsize+1),0);
	print IN2 $data."\n";
	close(IN2);
	
	return($out_data);
	
}

sub get_all{
	
	(*db_dat_p) = @_;

	#---
	$dbflag  = $db_dat_p{"dbflag" };
	$dbmain  = $db_dat_p{"dbmain" };
	$dbsize  = $db_dat_p{"dbsize" };
	$cntsize = $db_dat_p{"cntsize"};

	@out_array = ();
	
	if (! -e $dbmain       ){ return;                                                  }
	if (! open(IN2,$dbmain)){ return("ERROR:եɤ߼ݥ顼:minidb->get_all");}
	binmode IN2;
	while(<IN2>){
		push(@out_array,$_);
	}
	close(IN2);
	
	return(*out_array);
}

sub pick_up{
	
	($id,*db_dat_p) = @_;

	#---
	$dbflag  = $db_dat_p{"dbflag" };
	$dbmain  = $db_dat_p{"dbmain" };
	$dbsize  = $db_dat_p{"dbsize" };
	$cntsize = $db_dat_p{"cntsize"};
	
	if (! -e $dbmain       ){ return;                                                  }
	if (! open(IN2,$dbmain)){ return("ERROR:եɤ߼ݥ顼:minidb->pick_up");}
	binmode IN2;
	
	seek(IN2,$id*($dbsize+1),0);
	read(IN2,$out_data,$dbsize);
	close(IN2);
	
	return($out_data);
}

sub del_id{
	
	(*id_array,*db_dat_p) = @_;
	
	#---
	$dbflag  = $db_dat_p{"dbflag" };
	$cntsize = $db_dat_p{"cntsize"};
	
	if (! open(IN2,">>".$dbflag)){ return("ERROR:ե񤭹ߡݥ顼:minidb->del_id");}
	flock(IN2,2);
	binmode IN2;
	
	foreach $a (@id_array){
		$a = sprintf("%0".$cntsize."d",$a);
		print IN2 $a."\n";
	}
	
	close(IN2);
	
	return(1);
}


sub fill_space{
	
	(*f_str,$f_size) = @_;
	
	$fill_len = length($f_str);
	
	if   ($fill_len == $f_size){ return(1);                        }
	elsif($file_len >  $f_size){ $f_str = substr($f_str,0,$f_size);}
	
	foreach $a ($fill_len.. $f_size-1){
		$f_str .= " ";
	}
	
	return(1);
}

sub get_empty{
	
	($dbflag,$dbmain,$dbsize,$cntsize) = @_;
	
	$del_size = -s $dbflag;
	
	if ($del_size == 0){
		
		$out_data = 0;
		$out_data = (-s $dbmain) / ($dbsize+1) if $dbsize >= 0;
		
		$out_data = sprintf("%0".$cntsize."d",$out_data);
		
	}else{
		
		if (! open(IN2,"+<".$dbflag)){ return("ERROR:եɤ߼ꥨ顼:minidb->get_empty");}
		binmode IN2;
		
		seek(IN2,$del_size-$cntsize-1,0);
		read(IN2,$out_data,$cntsize);
		truncate(IN2,$del_size-$cntsize-1);
		
		close(IN2);
		
	}
	return($out_data);
}

