
#-------------------------------------------------------------------------------#
#               WebMailClientW[|[U[ݒ葀                   #
#                                                                               #
# Copyright 2002                                                                #
# ---LunarNight Lab.---                                                         #
# lunar-night@ninus.ocn.ne.jp                                                   #
# http://www.age.jp/~lunar/                                                     #
#-------------------------------------------------------------------------------#

#---f[^z
@data_array = ('name:j'     ,'mail',
               'mail_serv:s','user'  ,'pass','mail_port','prot_type','over_ssl:s','smtp_ssl:s',
               'smtp_serv:s','smtp_port:s','smtp_type:s','smtp_mode' ,
               'sendcopy:s' ,
               'b_serv:s'   ,'b_name:s' ,'b_port:s' ,'b_pass:s' ,'b_opt:s',
               'sieve_serv:s' ,'sieve_port:s','sieve_ssl:s',
               'imapscan:s');

return 1;

sub account_ctl{
	
	($mode,@opt) = @_;
	
	if   ($mode eq "ac_list" ){ return(&account_aclist  (@opt));}
	elsif($mode eq "ac_get"  ){ return(&account_acget   (@opt));}
	elsif($mode eq "ac_add"  ){ return(&account_acadd   (@opt));}
	elsif($mode eq "ac_del"  ){ return(&account_acdel   (@opt));}
	elsif($mode eq "ac_up"   ){ return(&account_acup    (@opt));}
	elsif($mode eq "ac_dn"   ){ return(&account_acdn    (@opt));}
	elsif($mode eq "chk_user"){ return(&account_chk_user(@opt));}
	elsif($mode eq "adduser" ){ return(&account_adduser (@opt));}
	elsif($mode eq "deluser" ){ return(&account_deluser (@opt));}
	elsif($mode eq "userlist"){ return(&account_userlist());    }
	elsif($mode eq "setpass" ){ return(&account_setpass (@opt));}
	elsif($mode eq "readpass"){ return(&account_readpass(@opt));}
	elsif($mode eq "getsign" ){ return(&account_getsign (@opt));}
	elsif($mode eq "getmode" ){ return(&account_getmode (@opt));}
	elsif($mode eq "setsign" ){ return(&account_setsign (@opt));}
	elsif($mode eq "chkaddr" ){ return(&account_chkaddr ());    }
	else                      { return('ERROR:account_ctl:sȃR}hł:'.$mode);}
}

#---AhXp
sub account_chkaddr{
	return("1");
}

#---AJEgړ
sub account_acdn{
	
	($auth_user,$ac_cnt) = @_;
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	$str = "";
	$cnt = 1;
	
	$use_file1 = $auth_folder.$tmp.".info";
	$use_file2 = $auth_folder.$tmp.".tmp";
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	while(<IN>){
		if ($cnt == $ac_cnt    ){ $str = $_;                               $cnt++; next;}
		if ($cnt == $ac_cnt + 1){ print OUT $_; print OUT $str; $str = ""; $cnt++; next;}
		print OUT $_;
		$cnt++;
	}
	print OUT $str if $str ne "";
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
}

#---AJEgړ
sub account_acup{
	
	($auth_user,$ac_cnt) = @_;
	
	#---G[`FbN
	if ($ac_cnt == 1){ return(1);}
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	$str = "";
	$cnt = 1;
	
	$use_file1 = $auth_folder.$tmp.".info";
	$use_file2 = $auth_folder.$tmp.".tmp";
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	while(<IN>){
		if ($cnt == $ac_cnt - 1){ $str = $_;                               $cnt++; next;}
		if ($cnt == $ac_cnt    ){ print OUT $_; print OUT $str; $str = ""; $cnt++; next;}
		print OUT $_;
		$cnt++;
	}
	print OUT $str if $str ne "";
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
}

#---ݒ
sub account_setsign{
	
	($auth_user,$ac_cnt,$sign) = @_;

	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	$end = 0;
	
	&jcode'convert(*sign,"sjis");
	
	$use_file2 = $auth_folder.$tmp.".tmp";
	$use_file1 = $auth_folder.$tmp.".info";
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	$cnt  =1 ;
	while(<IN>){
		($auth_dat,$sign_dat) = split(/\0/,$_);
		if ($cnt == $ac_cnt){
			$sign_dat = &encrypt('encrypt',$sign)."\n";
			$end = 1;
		}
		print OUT $auth_dat."\0".$sign_dat;
		$cnt++;
	}
	if ($end == 0 && $ac_cnt == 1){
		$sign_dat = &encrypt('encrypt',$sign)."\n";
		print OUT ""."\0".$sign_dat;
	}
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
	return(1);
	
}

#---擾
sub account_getsign{
	
	($auth_user,$ac_cnt) = @_;
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file1 = $auth_folder.$tmp.".info";
	open(IN ,$use_file1);
	$cnt  =1 ;
	$sign ="";
	while(<IN>){
		if ($cnt == $ac_cnt){
			($rc,$dec) = &encrypt('decrypt',substr($_,index($_,"\0")+1));
			if ($rc ne "1"){ last;}
			
			$sign = $dec;
			last;
		}
		$cnt++;
	}
	close(IN);
	
	return(1,$sign);
	
}

#---AJEg擾
sub account_acget{
	($auth_user,$ac_cnt) = @_;
	
	%user_info = ();
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file1 = $auth_folder.$tmp.".info";
	open(IN ,$use_file1);
	$cnt=1;
	$f  =0;
	while(<IN>){
		if ($cnt == $ac_cnt){
			($rc,$dec) = &encrypt('decrypt',substr($_,0,index($_,"\0")));
			if ($rc ne "1"){ last;}
			
			#---f[^i[
			@item = split(/\0/,$dec);
			$user_info{'ac_name'} = shift(@item);
			foreach $a (@data_array){
				($key,$opt) = split(/:/,$a);
				$user_info{$key} = shift(@item);
			}
			
			$f = 1;
			last;
		}
		$cnt++;
	}
	close(IN);
	
	if ($f == 0){ return('ERROR:AJEg񂪑݂Ȃ܂͕Ɏs܂');}
	
	return(1,*user_info);
}

#---AJEg폜
sub account_acdel{
	($auth_user,$ac_cnt) = @_;
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file = $auth_folder.$tmp.".info";
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file1 = $auth_folder.$tmp.".info";
	$use_file2 = $auth_folder.$tmp.".tmp";
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	$cnt=1;
	while(<IN>){
		($rc,$dec) = &encrypt('decrypt',substr($_,0,index($_,"\0")));
		if ($rc ne "1"){ $cnt++; next;}
		
		if ($cnt == $ac_cnt){ $cnt++; $ac_name = (split(/\0/,$dec))[0]; next;}
		print OUT $_;
		$cnt++;
	}
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
	&execute('writelog','del_ac',"AUTH=$auth_user AC_NAME=$ac_name ".$log_str);
	
	return(1);
}

#---AJEgǉ
sub account_acadd{
	($auth_user) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file = $auth_folder.$tmp.".info";
	
	#---f[^Zbg
	$tmp_data  = "";
	$err_opt   = "";
	$mx_mode   = "";
	$log_str   = "";
	foreach $a (@data_array){
		
		($val,$opt) = split(/:/,$a);
		
		$err_opt .= $val."," if $opt ne "s" && $in{$val} eq "" && $opt ne "j";
		$mx_mode  = $in{$val} if $val eq "use_mx";
		
		if ($opt eq "j"){ $tmp = $in{$val};
		                  &jcode'convert(*tmp,"sjis");
		                  $in{$val} = $tmp;           }
		
		$tmp_data       .= $in{$val}."\0";
		$log_str        .= $val."=".$in{$val}." " if $in{$val} ne "" && $val ne "pass";
	}
	$ac_name = $in{'ac_name'};
	&jcode'convert(*ac_name,'sjis');
	
	if ($err_opt ne ""         ){ return('ERROR:͍ڂ܂:'.$err_opt);}
	if ($mx_mode eq "1"      &&
	    $nslookup_path eq "" &&
	    $dsn_address   eq ""   ){ return('ERROR:ȈMTA@\𗘗pɂnslookuppX܂DNST[o[w肷Kv܂(^^;');}
	
	($rc,$tmp_data) = &encrypt('encrypt',$ac_name."\0".$tmp_data);
	
	open(IN,">>".$use_file);
	print IN $tmp_data."\0\n";
	close(IN);
	
	&execute('writelog','add_ac',"AUTH=$auth_user AC_NAME=$ac_name ".$log_str." pass=XXXXXXXX");
	
	return(1);
}

#---[U[`FbN
sub account_chk_user{
	($auth_user) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	$use_file1 = $auth_folder."account.dat";
	
	#---[U[`FbN
	open(IN ,$use_file1);
	$f   = 0;
	while(<IN>){
		($u,$d,$c) = split(/\0/,$_);
		if ($u eq $auth_user){
			$c = &encrypt('decrypt',$c);
			if ($c eq $auth_user){ $f = 1;}
			else                 { $f = 0;}
			last;
		}
	}
	close(IN);
	
	return($f);
	
}

#---AJEgXg
sub account_aclist{
	($auth_user) = @_;
	
	@out_aclist = ();
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	$tmp = &md5::convert($auth_user);
	$tmp = unpack('H*',$tmp);
	
	$use_file1 = $auth_folder.$tmp.".info";
	$use_file2 = $auth_folder.$tmp.".tmp";
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	$cnt=1;
	while(<IN>){
		($rc,$dec) = &encrypt('decrypt',substr($_,0,index($_,"\0")));
		if ($rc ne "1"){ next;}
		
		($acname) = split(/\0/,$dec);
		push(@out_aclist,$cnt."\0".$acname);
		print OUT $_;
		$cnt++;
	}
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
	return(1,*out_aclist);
}

#---pX[hǂݍ
sub account_readpass{
	($auth_user,$auth_pass) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	
	$use_file1 = $auth_folder."account.dat";
	
	#---ÍL[ݒ
	&encrypt('set_pass',$auth_user."\0".$auth_pass);
	
	#---[U[`FbN
	open(IN ,$use_file1);
	$f   = 0;
	$err = "";
	while(<IN>){
		($u,$d,$c,$l) = split(/\0/,$_);
		if ($u eq $auth_user){
			if ($d eq ""){ $f = "-1"; last;}
			
			#---ÍL[擾
			($rc,$pcode) = &encrypt('decrypt',$d);
			if ($rc ne "1"){ $err = '[U[܂̓pX[hႢ܂';}
			
			($rc,$seed) = &encrypt('set_pass',$pcode);
			$f = 1;
			last;
		}
	}
	close(IN);
	if($f == 0   ){ $err = '[U[܂̓pX[hႢ܂';}
	if($err ne ''){ return($err);                                 }
	
	return($f,$seed,$auth_user,$l);
	
}

#---p[hǂݍ
sub account_getmode{
	($auth_user) = @_;
	
	$use_file1 = $auth_folder."account.dat";
	
	#---[U[`FbN
	open(IN ,$use_file1);
	$f   = 0;
	$err = "";
	while(<IN>){
		($u,$d,$c,$l) = split(/\0/,$_);
		if ($u eq $auth_user){
			if ($d eq ""){ $f = "-1"; last;}
			$f = 1;
			last;
		}
	}
	close(IN);
	if($f == 0   ){ $err = '[U[܂̓pX[hႢ܂';}
	if($err ne ''){ return($err);                                 }
	
	return($f,$l);
	
}

#---pX[hݒ
sub account_setpass{
	
	($auth_user,$auth_pass) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5  ); #---MD5nbVOCu
	&load_lib($lib_des  ); #---DESÍCu
	&load_lib($lib_crypt); #---Í⏕Cu
	
	$use_file1 = $auth_folder."account.dat";
	$use_file2 = $auth_folder."account.tmp";
	
	#---ÍL[ݒ
	&encrypt('set_pass',$auth_user."\0".$auth_pass);
	
	#---[U[`FbN
	open(IN ,    $use_file1);
	open(OUT,">".$use_file2);
	$f = 0;
	while(<IN>){
		($u,$p,$c,$d) = split(/\0/,$_);
		if ($u eq $auth_user){
			if ($dat ne ""){ last; $f = 0;}
			$f = 1;
			
			#---ÍL[/L^
			$pcode = time().$auth_user.$auth_pass;
			$p = &encrypt('encrypt',$pcode);
			
			&encrypt('set_pass',$pcode);
			$c = &encrypt('encrypt',$auth_user);
		}
		print OUT $u."\0".$p."\0".$c."\0".$d."\0"."\n";
	}
	close(IN);
	close(OUT);
	
	if ($f == 0){ return('ERROR:pX[hݒς݂܂̓AJEg݂܂');}
	else        { rename($use_file2,$use_file1);                                     }
	
	return(1);
}

#---[U[Xg擾
sub account_userlist{
	
	@out_list = ();
	
	$fixflag  = "";
	$use_file = $auth_folder."account.dat";
	open(IN,$use_file);
	while(<IN>){
		chomp($_);
		($u,$p,$c,$d) = split(/\0/,$_);
		if ($u eq "" && $p eq "" && $c eq "" && $d eq ""){ $fixflag = "1"; next;}
		push(@out_list,$_);
	}
	close(IN);
	
	if ($fixflag eq "1"){
		open(IN,">".$use_file);
		foreach $a (@out_list){
			print IN $a."\n";
		}
		close(IN);
	}
	
	return(1,*out_list);
}

#---[U[ǉ
sub account_adduser{
	
	($auth_user,$direct) = @_;
	
	$use_file = $auth_folder."account.dat";
	open(IN,$use_file);
	while(<IN>){
		($tmp) = split(/\0/,$_);
		if ($tmp eq $auth_user){ return('[U[dĂ܂');}
	}
	close(IN);

	open(IN,">>".$use_file);
	print IN $auth_user."\0\0\0$direct\0\n";
	close(IN);
	
	if ($direct eq "1"){ $direct = "MODE=LIMITED";}
	else               { $direct = "";            }
	
	&execute('writelog','add_user',"AUTH=$auth_user $direct");
	
	return(1);
}

#---[U[폜
sub account_deluser{
	
	(*list_p) = @_;
	
	#---KpCuǂݍ
	&load_lib($lib_md5); #--MD5nbVOCu
	
	%tmp_hash = ();
	foreach $a (@list_p){ $tmp_hash{$a} = 1;}
	
	$use_file1 = $auth_folder."account.dat";
	$use_file2 = $auth_folder."account.tmp";
	open(OUT,">".$use_file2);
	open(IN ,$use_file1);
	while(<IN>){
		($tmp) = split(/\0/,$_);
		if ($tmp_hash{$tmp} == 1){ 
			$tmp = &md5::convert($tmp);
			$tmp = unpack('H*',$tmp);
			unlink $auth_folder.$tmp.".info" if -e $auth_folder.$tmp.".info";
			unlink $addr_folder.$tmp.".dat"  if -e $addr_folder.$tmp.".dat";
			unlink $addr_folder.$tmp.".pnt"  if -e $addr_folder.$tmp.".pnt";
			next;
		}
		print OUT $_;
	}
	close(IN);
	close(OUT);
	
	rename($use_file2,$use_file1);
	
	foreach $a (@list_p){
		&execute('writelog','del_user',"AUTH=$a");
	}
	
	return(1);
}

